	.area text(rom,rel)
	.dbfile ..\..\..\..\..\DOCUME~1\Steve\MYDOCU~1\icctest\ASIO_BETA\asio.c
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\icctest\ASIO_BETA\asio.c
	.dbfunc e show_val _show_val fI
;             ii -> R4
;        syncmap -> R3
;         pinmap -> R2
;           mask -> R1
;            val -> R5
_show_val::
	@FENTER	
	.long R4,R5,0	
	mov R5,R0	
	.dbline -1
	.dbline 20
; /**
;  * @file asio.c - defines implementation for an
;  * asynchronous serial IO driver for Propeller C bringup.
;  * This module can be used with 5MHz or 10MHz crystal.
;  * See header file for more details.
;  */
; #include "asio.h"
; 
; #undef ASIO_RXDEBUG
; 
; /**
;  * Show bits on oscilloscope. This is for debug only ... bits come out LSB first
;  * @param val is value to show
;  * @param mask is the byte/word/long mask
;  * @param pinmap is the pin bit map for bit stream output
;  * @param syncmap is the bit map for bit stream oscope sync
;  * @returns non-zero for looping;
;  */
; int show_val (int val, int mask, int pinmap, int syncmap)
; {
	.dbline 21
;     int ii = 1;
	mov R4,#1	
	.dbline 23
;     // set direction then set word syncmap bit
;     asm("or DIRA,%pinmap");
	or DIRA,R2
	.dbline 24
;     asm("or DIRA,%syncmap");
	or DIRA,R3
	.dbline 25
;     asm("or OUTA,%syncmap"); 
	or OUTA,R3
	rdlong PC,PC	
	.long L3	
L2:
	.dbline 27
; 
;     while(ii & mask) { // this works
	.dbline 28
;         if(val & ii) {
	test R5,R4	WZ
IF_E	rdlong PC,PC	
	.long L5	
	.dbline 28
	.dbline 29
;             asm("or   OUTA,%pinmap");
	or   OUTA,R2
	.dbline 30
;         }
	rdlong PC,PC	
	.long L6	
L5:
	.dbline 31
;         else {
	.dbline 32
;             asm("andn OUTA,%pinmap");
	andn OUTA,R2
	.dbline 33
;             asm("andn OUTA,%pinmap"); // waveform symetry
	andn OUTA,R2
	.dbline 34
;             asm("andn OUTA,%pinmap"); // waveform symetry
	andn OUTA,R2
	.dbline 35
;         }
L6:
	.dbline 36
;         ii = ii << 1;
	shl R4,#1	
	.dbline 37
;     }
L3:
	.dbline 27
	test R4,R1	WZ
IF_NE	rdlong PC,PC	
	.long L2	
	.dbline 38
;     asm("andn OUTA,%syncmap");
	andn OUTA,R3
	.dbline 39
;     return 1;
	mov R0,#1	
	.dbline -2
L1:
	@FPOP	
	.long R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r ii 4 I
	.dbsym r syncmap 3 I
	.dbsym r pinmap 2 I
	.dbsym r mask 1 I
	.dbsym r val 5 I
	.dbend
	.dbfunc e asio_init _asio_init fV
;           bits -> R0
_asio_init::
	.dbline -1
	.dbline 47
; }
; 
; /**
;  * Init direction bits.
;  * Would init baud here, but using const vs var has different timing.
;  */
; void    asio_init (void)
; {
	.dbline 48
;     int bits = ASIO_TX_PIN_MAP;
	@FLOAD	
	.long 1073741824	
	mov R0,TEMP0	
	.dbline 49
;     asm("MOV  DIRA,%bits");
	MOV  DIRA,R0
	.dbline -2
L7:
	@FRET	
	.dbline 0 ; func end
	.dbsym r bits 0 I
	.dbend
	.dbfunc s setbit _setbit fV
;            per -> R5
;         gttime -> R4
;            pin -> R1
;            val -> R0
_setbit:
	@FENTER	
	.long R4,R5,0	
	.dbline -1
	.dbline 58
; }
; 
; /**
;  * Sets a pinmap bit to a value for baudrate bit period.
;  * @param val is bit value to set.
;  * @param pin is pin bitmap
;  */
; static void setbit(int val, int pin)
; {
	.dbline 59
;     int per  = ASIO_BASE_PERIOD*ASIO_BAUDX_TX;
	@FLOAD	
	.long 600	
	mov R5,TEMP0	
	.dbline 61
; 	int gttime;
;     asm("mov        %gttime, cnt");
	mov        R4, cnt
	.dbline 62
;     asm("add        %gttime, %per");
	add        R4, R5
	.dbline 63
;     if(val) {
	cmp R0,#0	WZ
IF_E	rdlong PC,PC	
	.long L9	
	.dbline 63
	.dbline 64
;         asm("or     OUTA, %pin");
	or     OUTA, R1
	.dbline 65
;     }
	rdlong PC,PC	
	.long L10	
L9:
	.dbline 66
;     else {
	.dbline 67
;         asm("andn   OUTA, %pin");
	andn   OUTA, R1
	.dbline 68
;     }
L10:
	.dbline 69
;     asm("waitcnt    %gttime, #0");
	waitcnt    R4, #0
	.dbline -2
L8:
	@FPOP	
	.long R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r per 5 I
	.dbsym r gttime 4 I
	.dbsym r pin 1 I
	.dbsym r val 0 I
	.dbend
	.dbfunc e asio_tx _asio_tx fV
;           mask -> R8
;            stp -> R6
;            pin -> R5
;             ii -> R4
;            val -> R7
_asio_tx::
	@FENTER	
	.long R4,R5,R6,R7,R8,R15,0	
	mov R7,R0	
	.dbline -1
	.dbline 78
; }
; 
; 
; /**
;  * Transmit a char on interface.
;  * @param val is byte to send
;  */
; void    asio_tx (char val)
; {
	.dbline 79
;     int ii = 1;
	mov R4,#1	
	.dbline 80
;     int mask = 0xFF;
	mov R8,#255	
	.dbline 81
;     int pin  = ASIO_TX_PIN_MAP;
	@FLOAD	
	.long 1073741824	
	mov R5,TEMP0	
	.dbline 82
;     int stp  = 1;
	mov R6,#1	
	.dbline 84
; 
;     if (ASIO_TX_INVERTED) {
	rdlong PC,PC	
	.long L12	
L12:
	.dbline 88
;         val = (volatile)~val;
;         stp = (volatile)~stp & 1;
;     }
;     else { // waste time for symetry ... volatile to keep out optimization?
	.dbline 89
;         val = (volatile)val;
	mov R15,R7	
	and R15,#255	
	mov R7,R15	
	.dbline 90
;         stp = (volatile)stp & 1;
	and R6,#1	
	.dbline 91
;     }
L13:
	.dbline 93
; 
;     for(ii = 0; ii < 4; ii++) {
	mov R4,#0	
L14:
	.dbline 93
	.dbline 94
;         setbit(stp, pin); // stop bits
	mov R0,R6	
	mov R1,R5	
	@FCALL	
	.long _setbit	
	.dbline 95
;     }
L15:
	.dbline 93
	add R4,#1	
	.dbline 93
	cmps R4,#4	WC
IF_B	rdlong PC,PC	
	.long L14	
	.dbline 97
;         
;     setbit((~stp & 1), pin); // start bit
	neg R15,R6	
	sub R15,#1	
	mov R0,R15	
	and R0,#1	
	mov R1,R5	
	@FCALL	
	.long _setbit	
	.dbline 98
;     ii = 1;
	mov R4,#1	
	rdlong PC,PC	
	.long L19	
L18:
	.dbline 99
;     while(ii & mask) { // this works
	.dbline 100
;         if(val & ii) {
	mov R15,R7	
	and R15,#255	
	test R15,R4	WZ
IF_E	rdlong PC,PC	
	.long L21	
	.dbline 100
	.dbline 101
;             setbit(1, pin);
	mov R0,#1	
	mov R1,R5	
	@FCALL	
	.long _setbit	
	.dbline 102
;         }
	rdlong PC,PC	
	.long L22	
L21:
	.dbline 103
;         else {
	.dbline 104
;             setbit(0, pin);
	mov R0,#0	
	mov R1,R5	
	@FCALL	
	.long _setbit	
	.dbline 105
;         }
L22:
	.dbline 106
;         ii = ii << 1;
	shl R4,#1	
	.dbline 107
;     }
L19:
	.dbline 99
	test R4,R8	WZ
IF_NE	rdlong PC,PC	
	.long L18	
	.dbline 108
;     for(ii = 0; ii < ASIO_STOP_BITS; ii++) {
	mov R4,#0	
L23:
	.dbline 108
	.dbline 109
;         setbit(stp, pin); // stop bits
	mov R0,R6	
	mov R1,R5	
	@FCALL	
	.long _setbit	
	.dbline 110
;     }
L24:
	.dbline 108
	add R4,#1	
	.dbline 108
	cmps R4,#8	WC
IF_B	rdlong PC,PC	
	.long L23	
	.dbline -2
L11:
	@FPOP	
	.long R15,R8,R7,R6,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r mask 8 I
	.dbsym r stp 6 I
	.dbsym r pin 5 I
	.dbsym r ii 4 I
	.dbsym r val 7 c
	.dbend
	.dbfunc e asio_txString _asio_txString fV
;            str -> R4
_asio_txString::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 118
; }
; 
; /**
;  * Transmit a string on interface.
;  * @param str is string to send.
;  */
; void    asio_txString (char* str)
; {
	rdlong PC,PC	
	.long L29	
L28:
	.dbline 119
;     while(*str != 0) {
	.dbline 120
;         asio_tx(*str);
	rdbyte R15,R4	
	mov R0,R15	
	and R0,#255	
	@FCALL	
	.long _asio_tx	
	.dbline 121
;         str++;
	add R4,#1	
	.dbline 122
;     }
L29:
	.dbline 119
	rdbyte R15,R4	
	and R15,#255	WZ
IF_NE	rdlong PC,PC	
	.long L28	
	.dbline -2
L27:
	@FPOP	
	.long R15,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r str 4 pc
	.dbend
	.dbfunc s getbit _getbit fI
;           bits -> R7
;         grtime -> R5
;            per -> R6
;             rc -> R4
;            pin -> R8
_getbit:
	@FENTER	
	.long R4,R5,R6,R7,R8,0	
	mov R8,R0	
	.dbline -1
	.dbline 131
; }
; 
; /**
;  * Get a bit from pinmap on the baud schedule
;  * @param pin is pin bitmap
;  * @returns int representing bit value 1 or 0
;  */
; static int getbit (int pin)
; {
	.dbline 132
;     int rc = 0;
	mov R4,#0	
	.dbline 134
;     int bits;
;     int per  = ASIO_BASE_PERIOD*ASIO_BAUDX_RX;
	mov R6,#120	
	.dbline 136
; 	int	grtime;
;     asm("mov        %grtime, cnt");
	mov        R5, cnt
	.dbline 137
;     asm("add        %grtime, %per");
	add        R5, R6
	.dbline 138
;     asm("waitcnt    %grtime, %per");
	waitcnt    R5, R6
	.dbline 143
;     // for debugging
;     //asm("xor  OUTA,#$1");
;     
;     // get bit
;     asm("mov %bits, INA"); 
	mov R7, INA
	.dbline 144
;     rc = (bits & pin) ? ~ASIO_RX_INVERTED : ASIO_RX_INVERTED;
	test R7,R8	WZ
IF_E	rdlong PC,PC	
	.long L33	
	@FLOAD	
	.long -1	
	mov R5,TEMP0	
	rdlong PC,PC	
	.long L34	
L33:
	mov R5,#0	
L34:
	mov R4,R5	
	.dbline 145
;     rc &= 1;
	and R4,#1	
	.dbline 146
;     return rc;
	mov R0,R4	
	.dbline -2
L31:
	@FPOP	
	.long R8,R7,R6,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r bits 7 I
	.dbsym r grtime 5 I
	.dbsym r per 6 I
	.dbsym r rc 4 I
	.dbsym r pin 8 I
	.dbend
	.dbfunc e asio_rx _asio_rx fI
;         grtime -> R8
;            per -> R7
;           bits -> R9
;             ii -> R5
;             rx -> R6
;           byte -> R4
_asio_rx::
	@FENTER	
	.long R4,R5,R6,R7,R8,R9,R15,0	
	.dbline -1
	.dbline 155
; }
; 
; /**
;  * Get a byte from the serial interface.
;  * param are set by # define constants in asio.h
;  * @returns int representing byte received.
;  */
; int     asio_rx (void)
; {
	.dbline 159
;     int ii;
;     int bits;
;     int rx; 
;     int byte = 0;
	mov R4,#0	
	.dbline 161
;     int grtime;
;     int per  = (ASIO_BASE_PERIOD*ASIO_BAUDX_RX);
	mov R7,#120	
	.dbline 162
;     per += 800; // add some start sample margin for higher baudrates
	@FLOAD	
	.long 800	
	add R7,TEMP0	
L36:
	.dbline 169
;      
; #ifdef ASIO_RXDEBUG  
;     // for debugging  
;     asm("or   DIRA,#$7");
; #endif
; 
;     do {
	.dbline 170
;         asm("mov %bits, INA");
	mov R9, INA
	.dbline 171
;         rx = (bits & ASIO_RX_PIN_MAP) ? 0 : 1;
	@FLOAD	
	.long -2147483648	
	test R9,TEMP0	WZ
IF_E	rdlong PC,PC	
	.long L40	
	mov R5,#0	
	rdlong PC,PC	
	.long L41	
L40:
	mov R5,#1	
L41:
	mov R6,R5	
	.dbline 172
;     } while(rx == ASIO_RX_INVERTED);
L37:
	.dbline 172
	cmp R6,#0	WZ
IF_E	rdlong PC,PC	
	.long L36	
	.dbline 180
; 
; #ifdef ASIO_RXDEBUG  
;     // for debugging  
;     asm("xor   OUTA,#$4"); 
; #endif
; 
;     // wait for start bit to pass    
;     asm("mov        %grtime, cnt");
	mov        R8, cnt
	.dbline 181
;     asm("add        %grtime, %per");
	add        R8, R7
	.dbline 182
;     asm("waitcnt    %grtime, %per");
	waitcnt    R8, R7
	.dbline 185
; 
;     // get bits on baud rate schedule
;     for(ii = 0; ii < 8; ii++) {
	mov R5,#0	
L42:
	.dbline 185
	.dbline 186
;         rx = getbit(ASIO_RX_PIN_MAP);
	@FLOAD	
	.long -2147483648	
	mov R0,TEMP0	
	@FCALL	
	.long _getbit	
	mov R6,R0	
	.dbline 187
;         byte = byte | (rx << 8);
	mov R15,R0	
	shl R15,#8	
	or R4,R15	
	.dbline 188
;         byte = byte >> 1;
	sar R4,#1	
	.dbline 189
;     }
L43:
	.dbline 185
	add R5,#1	
	.dbline 185
	cmps R5,#8	WC
IF_B	rdlong PC,PC	
	.long L42	
	.dbline 190
;     getbit(ASIO_RX_PIN_MAP); // get stop bit
	@FLOAD	
	.long -2147483648	
	mov R0,TEMP0	
	@FCALL	
	.long _getbit	
	.dbline 192
;   
;     return byte;
	mov R0,R4	
	.dbline -2
L35:
	@FPOP	
	.long R15,R9,R8,R7,R6,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r grtime 8 I
	.dbsym r per 7 I
	.dbsym r bits 9 I
	.dbsym r ii 5 I
	.dbsym r rx 6 I
	.dbsym r byte 4 I
	.dbend
	.dbfunc e asio_rxString _asio_rxString fI
;           byte -> R7
;             ii -> R4
;            len -> R6
;            str -> R5
_asio_rxString::
	@FENTER	
	.long R4,R5,R6,R7,R14,R15,0	
	mov R5,R0	
	mov R6,R1	
	.dbline -1
	.dbline 205
; }
; 
; /**
;  * Prefer using a buffer head/tail strategy provided by starting a COG.
;  * For now use asio_rx byte by byte blocking calls.
;  * Use calls to asio_rx until a terminator like "\r" is found.
;  * All strings returned are null terminated.
;  * @param str is a predefined input buffer of len.
;  * @param len is maximum number of chars to receive in buffer.
;  * @returns number of bytes received.
;  */
; int asio_rxString (char* str, int len)
; {
	.dbline 206
;     int byte = 0;
	mov R7,#0	
	.dbline 207
;     int ii = 0;
	mov R4,#0	
L47:
	.dbline 208
;     do {
	.dbline 209
;         byte = asio_rx();
	@FCALL	
	.long _asio_rx	
	mov R7,R0	
	.dbline 210
;         str[ii] = byte;
	mov R15,R4	
	add R15,R5	
	mov R14,R7	
	wrbyte R14,R15	
	.dbline 211
;         if(byte == ASIO_ENTER) {
	cmp R7,#13	WZ
IF_NE	rdlong PC,PC	
	.long L50	
	.dbline 211
	.dbline 212
;            break;
	rdlong PC,PC	
	.long L49	
L50:
	.dbline 214
;         }
;         ii++;
	add R4,#1	
	.dbline 215
;     } while(ii < len);
L48:
	.dbline 215
	cmps R4,R6	WC
IF_B	rdlong PC,PC	
	.long L47	
L49:
	.dbline 217
;     
;     if(ii < (len-1)) ii++;
	mov R15,R6	
	sub R15,#1	
	cmps R4,R15	WC
IF_AE	rdlong PC,PC	
	.long L52	
	.dbline 217
	add R4,#1	
L52:
	.dbline 218
;     str[ii] = '\0';
	mov R15,R4	
	add R15,R5	
	mov R14,#0	
	wrbyte R14,R15	
	.dbline 220
;     
;     return ii;
	mov R0,R4	
	.dbline -2
L46:
	@FPOP	
	.long R15,R14,R7,R6,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r byte 7 I
	.dbsym r ii 4 I
	.dbsym r len 6 I
	.dbsym r str 5 pc
	.dbend
	.dbfunc e main _main fI
;          rxbuf -> HRSP+0
;             ii -> R4
;           argv -> <dead>
;           argc -> <dead>
_main::
	sub HRSP,#256	
	.dbline -1
	.dbline 226
; }
; 
; //#define ASIO_TEST
; #ifdef  ASIO_TEST
; int main (int argc, char** argv)
; {
	.dbline 227
;     int ii = 0;
	mov R4,#0	
	.dbline 230
;     char rxbuf[ASIO_BUFF_LEN+1]; 
; 
;     asio_init();
	@FCALL	
	.long _asio_init	
	.dbline 232
;     
;     asio_rx(); // block until user opens connection
	@FCALL	
	.long _asio_rx	
	.dbline 233
;     asio_txString("Hello World!\r\n");
	@FLOAD	
	.long L55	
	mov R0,TEMP0	
	@FCALL	
	.long _asio_txString	
	.dbline 235
;     
;     while(0) {
	.dbline 237
;         //show_val(ii, 0xffff, 0x1, 0x2);
;     }
	.dbline 235
	rdlong PC,PC	
	.long L75	
L59:
	.dbline 238
;     while(0) {
	.dbline 239
;         asio_tx('U');
	mov R0,#85	
	@FCALL	
	.long _asio_tx	
	.dbline 240
;     }
	.dbline 238
	rdlong PC,PC	
	.long L75	
L62:
	.dbline 241
;     while(0) {
	.dbline 242
;         asio_tx('H');
	mov R0,#72	
	@FCALL	
	.long _asio_tx	
	.dbline 243
;         asio_tx('i');
	mov R0,#105	
	@FCALL	
	.long _asio_tx	
	.dbline 244
;         asio_tx(' ');
	mov R0,#32	
	@FCALL	
	.long _asio_tx	
	.dbline 245
;     }
	.dbline 241
	rdlong PC,PC	
	.long L75	
L65:
	.dbline 246
;     while(0) {
	.dbline 247
;         asio_txString("Hello World!\r\n");
	@FLOAD	
	.long L55	
	mov R0,TEMP0	
	@FCALL	
	.long _asio_txString	
	.dbline 248
;     }
	.dbline 246
	rdlong PC,PC	
	.long L75	
L68:
	.dbline 249
;     while(0) {
	.dbline 250
;         ii = asio_rx();
	@FCALL	
	.long _asio_rx	
	mov R4,R0	
	.dbline 252
;         //show_val(ii, 0xff, 0x1, 0x2);
;     }
	.dbline 249
	rdlong PC,PC	
	.long L75	
L71:
	.dbline 253
;     while(0) {  // echo test
	.dbline 254
;         asio_tx(asio_rx());
	@FCALL	
	.long _asio_rx	
	and R0,#255	
	@FCALL	
	.long _asio_tx	
	.dbline 255
;     }
	.dbline 253
	rdlong PC,PC	
	.long L75	
L74:
	.dbline 256
;     while(1) {  // echo string test
	.dbline 257
;         ii = asio_rxString(rxbuf, ASIO_BUFF_LEN);
	mov R0,HRSP	
	mov R1,#255	
	@FCALL	
	.long _asio_rxString	
	.dbline 259
;         //show_val(ii, 0xff, 0x1, 0x2);
;         for(ii = 0; ii < 500; ii++) ; // pause before send
	mov R4,#0	
L77:
	.dbline 259
L78:
	.dbline 259
	add R4,#1	
	.dbline 259
	cmps R4,#500	WC
IF_B	rdlong PC,PC	
	.long L77	
	.dbline 260
;         asio_txString(rxbuf);
	mov R0,HRSP	
	@FCALL	
	.long _asio_txString	
	.dbline 261
;     }
L75:
	.dbline 256
	rdlong PC,PC	
	.long L74	
X0:
	.dbline -2
L54:
	add HRSP,#256	
	@FRET	
	.dbline 0 ; func end
	.dbsym l rxbuf 0 A[256:256]c
	.dbsym r ii 4 I
	.dbsym l argv 255 ppc
	.dbsym l argc 255 I
	.dbend
	.area lit(rom,rel)
L55:
	.byte 'H,'e,'l,'l,'o,32,'W,'o,'r,'l,'d,33,13,10,0
